/*
 *  Output data to 7seg-LED over the SPI bus
 *
 *  Physical pin of Raspberry Pi 3
 *    SPI_MOSI = 19
 *    SPI_MISO = 21 : Not used
 *    SPI_CLK  = 23
 *    SPI_CE0  = 24
 *    SPI_CE1  = 26
*/

#include <stdio.h>
#include <stdlib.h>
#include <wiringPi.h> // GPIO 制御用ヘッダ
#include <wiringPiSPI.h>
#include "out7seg.h"

int init_SegLED()
{
    return wiringPiSPISetupMode(SPI_CH, SPI_SPEED, SPI_MODE);
}

void SegLED_out(unsigned char bin)
{
    unsigned char data = bin;
    wiringPiSPIDataRW(SPI_CH, &data, 1);
}

// 74HC595: dp,g,f,e,d,c,b,a, active HIGH
static unsigned char SegLED_led_data[16] = {

    0x3f, 0x06, 0x5b, 0x4f, 0x66, 0x6d, 0x7d, 0x27,
    0x7f, 0x6f, 0x77, 0x7c, 0x39, 0x5e, 0x79, 0x71
};

unsigned char SegLED_BinTo7seg(int bin, int dp)
{
    unsigned char cd;

    cd = SegLED_led_data[bin & 0x0f];
    if (dp)
        cd |= 0x80;
    return cd;
}
